   import javax.swing.*;
   import javax.swing.event.*;
   import javax.swing.tree.*;
   import java.io.*;
   import javax.media.*;
   import javax.media.format.*;
   import javax.media.util.*;
   import javax.media.control.*;
   import javax.media.protocol.*;
   import java.util.*;
   import java.awt.*;
   import java.awt.image.*;
   import java.awt.event.*;
   import com.sun.image.codec.jpeg.*;

   import javax.imageio.ImageIO;				//per aprire l'immagine
   import java.awt.image.BufferedImage;
   import java.io.IOException;
   import java.io.File;
   import java.lang.NullPointerException;


/*Classe in cui il Sig Salutino nasce
@author Agostini, Carlon, De Cassai
@version 0.12 Stabile fino a il baricentro WIP 03GIU07
@version 0.15 Aggiunta applet e gui definitiva WIP 04GIU07
@version 0.16 approccio all'oggetto Hand
@version 0.17 modificata etichetta punti 07GIU07
@version 0.20 rotazione e posizione centrale DEFINITIVI punti 08GIU07
@version 0.21 anche la distanza
*/
 
    public class MR_HI extends Panel implements ActionListener {
      private static final double VERS=0.21;
   
      public static Player player = null;
      public CaptureDeviceInfo di = null;
      public MediaLocator ml = null;
      public JButton pulsante = null;
      public Buffer buf = null;
      public Image img = null;
      public VideoFormat vf = null;
      public BufferToImage btoi = null;
   
      private static final int MAXIMUM_ACQ=1000;//numero massimo di acquisizione
   
      private static int NUM_MAX_SET = 5;//numero di sensori da individuare
   
      public JButton chiudi=new JButton("Esci");
      public JButton reset=new JButton ("Reset");
      public JButton spacer = new JButton(new ImageIcon("spacer.jpg") );
      public JButton spacerExt = new JButton(new ImageIcon("spacerEsteso.jpg") );
      public Label info=new Label("Riepilogo");
      public Label stato=new Label("--");
      public Label titolo=new Label("Sig. Salutino");
      public Label n_punti=new Label("NaN");
      public Label distanza=new Label("NaN");
      public Label rotazione=new Label("NaDegree");
      public Label posizione=new Label("(NaN,NaN)");
      public Label clic=new Label("______");
      public JPanel intestazione=new JPanel();
      public JPanel comandi=new JPanel();
      public JPanel centro=new JPanel();
      public JPanel variabili=new JPanel();
      public JPanel zona_programma=new JPanel();
      public JPanel fondo=new JPanel();
      private Display disegno;
      private Component comp=null;
   
      public ImagePanel logo = null;
   //variabili x grafica
   
      private static Frame f = new Frame("MRHI vers. "+VERS);
      private static final Color TESTO_VAR=Color.white;
      private static final Color NOME_VAR=new Color(000,138,255);
      private static final Color SFONDO=Color.black;
      private static final int WIDTH=200;
      private static final int MAX_H=760;
      private static final int HEADER_H=100;		
      private static final int FOOTER_H=60;
      private static int altezza_gui=MAX_H;
 
  
   	
       public MR_HI(){
         disegno=new Display();	
        
      //definisco i comandi
         pulsante = new JButton("Acquisisci");
         pulsante.addActionListener(this);
         chiudi.addActionListener(this);
         reset.addActionListener(this);
      
         JPanel comandi2r=new JPanel();
         comandi2r.setLayout(new GridLayout(1,2));	
         comandi.setLayout(new GridLayout(2,1));
         comandi2r.add(chiudi);
         comandi2r.add(reset);
         comandi.add(pulsante);
         comandi.add(comandi2r);
      
      
         spacer.addActionListener(this);
         spacer.setBackground(SFONDO);
         spacerExt.addActionListener(this);
         spacerExt.setBackground(SFONDO);
      
      
      
         intestazione.add(new JLabel(new ImageIcon("logo.jpg")));
         Label t0=new Label("Frame:");
         variabili.add(t0);t0.setBackground(SFONDO);t0.setForeground(NOME_VAR);
         variabili.add(stato);stato.setBackground(SFONDO);stato.setForeground(TESTO_VAR);
         Label t1=new Label("N Marker/Punti:");
         variabili.add(t1);t1.setBackground(SFONDO);t1.setForeground(NOME_VAR);
         variabili.add(n_punti);n_punti.setBackground(SFONDO);n_punti.setForeground(TESTO_VAR);
         Label t2=new Label("Distanza:");
         variabili.add(t2);t2.setBackground(SFONDO);t2.setForeground(NOME_VAR);
         variabili.add(distanza);distanza.setBackground(SFONDO);distanza.setForeground(TESTO_VAR);
         Label t3=new Label("Rotazione:");
         variabili.add(t3);t3.setBackground(SFONDO);t3.setForeground(NOME_VAR);
         variabili.add(rotazione);rotazione.setBackground(SFONDO);rotazione.setForeground(TESTO_VAR);
         Label t4=new Label("X,Y:");
         variabili.add(t4);t4.setBackground(SFONDO);t4.setForeground(NOME_VAR);
         variabili.add(posizione);posizione.setBackground(SFONDO);posizione.setForeground(TESTO_VAR);
         Label t5=new Label("Clic:");
         variabili.add(t5);t5.setBackground(SFONDO);t5.setForeground(NOME_VAR);
         variabili.add(clic);clic.setBackground(SFONDO);clic.setForeground(TESTO_VAR);
         intestazione.setBackground(SFONDO);	
         pulsante.setBackground(SFONDO);pulsante.setForeground(Color.green);
         chiudi.setBackground(SFONDO);chiudi.setForeground(Color.red);
         reset.setBackground(SFONDO);reset.setForeground(Color.red);
         disegno.setBackground(SFONDO);
         try{//cerco di creare il riproduttore video
            player = Manager.createRealizedPlayer(new MediaLocator("vfw://0"));
            player.start();      
            comp = player.getVisualComponent();
         }
             catch (Exception e){e.printStackTrace();}
         creaGUI(true);
      }
   //se do boolean=true voglio disegnare skermata estesa
       private void creaGUI(boolean e){
      //	removeAll();
         zona_programma.removeAll();
         int k=2;//numero elementi zona programma
         if (e){
            altezza_gui=MAX_H;
            k++;}
         else{
            altezza_gui=WIDTH*k+HEADER_H+FOOTER_H;
         
         }
         comandi.setSize(WIDTH,FOOTER_H);
         intestazione.setSize(WIDTH,HEADER_H);
         zona_programma.setSize(WIDTH,WIDTH*k);
         zona_programma.setLayout(new GridLayout(k,1,0,0));
         setLayout(new BorderLayout());
         variabili.setLayout(new GridLayout(6,2));
         centro.removeAll();
         centro.setLayout(new BorderLayout());
         centro.add(disegno,BorderLayout.CENTER);
         if (e)
            centro.add(spacerExt,BorderLayout.SOUTH);
         else
            centro.add(spacer,BorderLayout.SOUTH);
         if (comp != null)
            zona_programma.add(comp);
         zona_programma.add(centro);
         if (e) 
            zona_programma.add(variabili);
         add(intestazione,BorderLayout.NORTH);
         add(zona_programma, BorderLayout.CENTER);
         add(comandi, BorderLayout.SOUTH);
         setSize(WIDTH,altezza_gui);
      //	f.pack();
         f.setSize(new Dimension(WIDTH,altezza_gui));
         f.setVisible(true);
         repaint();
         validate();
      }
   
   //il main di sig. Salutino..Buon giorno sig salutino!!!  
       public static void main(String[] args)  throws Exception{
         MR_HI cf = new MR_HI();
         f.addWindowListener(
                new WindowAdapter() {
                   public void windowClosing(WindowEvent e) {
                     playerclose(); System.exit(0);
                  }
               });
         f.add("Center",cf);
      //		f.pack();																//capire perke non serve!
         f.setSize(new Dimension(WIDTH,altezza_gui));
         f.setResizable(false);//impedisco di cambiare le dimensioni
         f.setVisible(true);
      }//main
   
   
       public static void playerclose(){
         player.close(); player.deallocate();
      }
   //con questo metodo si gestisce l'interazione con il mouse
       public void actionPerformed(ActionEvent e){
         JComponent c = (JComponent) e.getSource();
      //se avviene questo comando sto per restringere il quadro
         if (c==spacerExt){
            creaGUI(false);		
         }
      //se avviene questo comando sto per espandere il quadro
         if (c==spacer){
            creaGUI(true);		
         }
      //se premo il pulsante "esci"
         if (c==chiudi){System.exit(0);}
      //se premo il pulsante "reset"
         if (c==reset){
            aggiorna("--","NaN","NaN","NaN","NaDegree","NaN, NaN","");
         }
      //se premo il pulsante acquisizione
         if (c == pulsante) {
            pulsante.setLabel("Acquisizione");//controllare se la posizione  corretta
         //prendo il controllo del video
            FrameGrabbingControl fgc=(FrameGrabbingControl)player.getControl("javax.media.control.FrameGrabbingControl");
         //acquisisco dei frame
            HandHandler hh=new HandHandler();
            boolean inizializzato=false;//qui vedo se  partito
            boolean ferma_acq=false;//comando passato dal guanto 
            int i=0;
            while(i<MAXIMUM_ACQ&&(!ferma_acq)){
               i++;
               buf = fgc.grabFrame();
               try{Thread.sleep(50);}
                   catch (InterruptedException ee){}
            // converto il frame in immagine
               btoi = new BufferToImage((VideoFormat)buf.getFormat());
               img = btoi.createImage(buf);
               BufferedImage imma=(BufferedImage)img;
               ImageStreaming frame=new ImageStreaming(imma).CleanGrey();
            //				frame.toFile("D:\\dati_3d\\snapshot\\frame_"+i);//per salvare il frame attuale
               Hand f=new Hand(frame);
               if (!inizializzato){
                  hh=new HandHandler(f);
                  inizializzato=hh.initializated();
                  aggiorna(""+i,"NaN","NaN","NaN","NaDegree","NaN, NaN","");
               }
               else {
                  hh.refresh(f);
                  Point2D off=hh.getCentralPosition();
                  boolean[] clic=hh.clic();
               	
						
						if (hh.l_clic)
							Mouse.ClickPoint(hh.coordinate_schermo.getX(), hh.coordinate_schermo.getY(), Mouse.BUTTON_1);
						else
							if (hh.double_l_clic){
								Mouse.ClickPoint(hh.coordinate_schermo.getX(), hh.coordinate_schermo.getY(), Mouse.BUTTON_1);
								Mouse.ClickPoint(hh.coordinate_schermo.getX(), hh.coordinate_schermo.getY(), Mouse.BUTTON_1);

							}else{
								if (hh.r_clic){
								Mouse.ClickPoint(hh.coordinate_schermo.getX(), hh.coordinate_schermo.getY(), Mouse.BUTTON_2);
								}
								
								else{
									Mouse.SetCursorPos(hh.coordinate_schermo.getX(), hh.coordinate_schermo.getY());
								}
							
							
							}
							
						
               
                  aggiorna(i,f.getNumberSet(),frame.contRGB(-1),hh.getDistance(),hh.getRotation(),off.getX(),off.getY(),clic[0],clic[1]);//sistemo output
                  ferma_acq=hh.haveiToStop();
               }
            
            
            
            
               }//while
         //reinizializzo il pulsante
            pulsante.setLabel("Acquisisci");//controllare se la posizione  corretta
         }//c=pulsante
      }//action
   
   
   //aggiorno i valori di output testuale	
       private void aggiorna(int f,int m,int p,double d, double a,double x, double y,boolean sx, boolean dx){ 
         String c="";
         if (sx) c=c+"SX_";
         else c=c+"___";
         if (dx) c=c+"_DX";
         else c=c+"___";
         aggiorna(""+f,""+m,""+p,""+d,""+a,""+x+", "+y,c);	
      }
   
   //aggiorno i valori di output		
       private void aggiorna(String f, String m,String p, String d, String a, String coord, String c){
         stato.setText("  "+f);
         n_punti.setText("  "+m+"/"+p);
         distanza.setText("  "+d);
         rotazione.setText("  "+a);
         posizione.setText(" ("+coord+")");
         clic.setText("  "+c);
      }
   	
   	
   //classe pr inserire immagini nei Panel
       class ImagePanel extends Panel{
         public Image myimg = null;
      
          public ImagePanel(){
            setLayout(null); setSize(170,120);
         }
      	
          public ImagePanel(Image img){
            this(); setImage(img);
         }
      	
          public void setImage(Image img){
            this.myimg = img; repaint();
         }
      
          public void paint(Graphics g){
            if (myimg != null)
               g.drawImage(myimg, 0, 0, this);
         }
      }//class imagepanel
   
   //class display
       class Display extends JPanel{
      
         Point2D indice=new Point2D(95,35);
         Point2D medio=new Point2D(80,35);
         Point2D mano1=new Point2D(95,90);
         Point2D mano2=new Point2D(50,125);
         Point2D mano3=new Point2D(45,130);
      
      
          public void paint (Graphics g){
            g.setColor(SFONDO);
            g.fillRect(0,0,200,200);
         //Punto Indice
            quadropieno(g,indice,10,Color.green,TESTO_VAR);
         
         /*	g.setColor(Color.green); 
         g.fillRect(indiceX-5,indiceY-5,10,10);
         g.setColor(Color.black); 
         g.drawRect(indiceX-5,indiceY-5,10,10);*/
         //Punto Medio
            quadropieno(g,medio,10,Color.red,TESTO_VAR);
         /*	g.setColor(Color.red);
         riempi(medio,10);
         g.setColor(Color.black);
         quadro(medio,10);*/
            quadropieno(g,mano1,10,TESTO_VAR,SFONDO);
            quadropieno(g,mano2,10,TESTO_VAR,SFONDO);
            quadropieno(g,mano3,10,TESTO_VAR,SFONDO);
         
         
            quadrovuoto(g,mano1,10,TESTO_VAR);
            quadrovuoto(g,mano2,10,TESTO_VAR);
            quadrovuoto(g,mano3,10,TESTO_VAR);
         //Asse
            g.setColor(Color.red);
            g.drawLine(mano1.getX(),mano1.getY(),mano3.getX(),mano3.getY());
         
            g.setColor(TESTO_VAR);
         //Mano
            linea(g,mano1, mano3);
            rettangolo(g,mano1,mano3);
         //Pollice
            linea (g,new Point2D(mano1.getX(),mano1.getY()+30),new Point2D(mano1.getX()+30,mano1.getY()-10));
         //Indice
         
            g.drawLine(indice.getX(),indice.getY(),mano1.getX(),mano1.getY());
         
         //Medio
            g.drawLine(medio.getX(),medio.getY(),mano1.getX()-15,mano1.getY());
         //Anulare
            g.drawLine(medio.getX()-15,medio.getY()+5,mano1.getX()-30,mano1.getY());
         //Mignolo
            g.drawLine(medio.getX()-30,medio.getY()+15,mano1.getX()-45,mano1.getY());
         
         }
      
      //disegno un quadro di centro i e lato l
          private void quadropieno(Graphics g,Point2D p,int l, Color c1, Color c2){
            g.setColor(c1);
            g.fillRect(p.getX()-(l/2),p.getY()-(l/2),l,l);
            g.setColor(TESTO_VAR);
            g.drawRect(p.getX()-(l/2),p.getY()-(l/2),l,l);
         }
      //disegno un quadro di centro i e lato l
          private void quadrovuoto(Graphics g,Point2D p,int l, Color c1){
            g.setColor(c1);
            g.drawRect(p.getX()-(l/2),p.getY()-(l/2),l,l);
         }
      
          private void linea(Graphics g,Point2D a, Point2D b){
            g.drawLine(a.getX(),a.getY(),b.getX(), b.getY());
         }
      
          private void rettangolo(Graphics g, Point2D a,Point2D b){
            g.drawLine(a.getX(),a.getY(),b.getX(), a.getY());
            g.drawLine(a.getX(),a.getY(),a.getX(), b.getY());
            g.drawLine(b.getX(),a.getY(),b.getX(), b.getY());
            g.drawLine(a.getX(),b.getY(),b.getX(), b.getY());
         
         }
      
      
      }
   	
       public static void saveJPG(Image img, String s){
         try{
            BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_RGB);
            javax.imageio.ImageIO.write(bi, "bmp", new java.io.File(s+".bmp"));
         }
             catch(IOException e){	System.out.println("Errore nella creazione del file");
            }
      }
   
   
   
   }//CLASSE